//-----------------------------------------------------------------------------
// TP0
// dsPIC 30F3010
// L. BAGHLI 27/03/2006
// actionner des bouton input  port
// allumer des diodes output port
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//-----------------------------------------------------------------------------
#include "p30F3010.h"

//Configuration bits
_FOSC(CSW_FSCM_OFF & XT_PLL8);
_FWDT(WDT_OFF);
_FBORPOR(PBOR_OFF & BORV_27 & PWRT_16 & MCLR_EN);
_FGS(CODE_PROT_OFF);
//-----------------------------------------------------------------------------
//Program Specific Constants
#define FCY 8000000						//Instruction cycle rate (Osc x PLL / 4)
#define FPWM 10000						//PWM freq
#define MILLISEC FCY/8000			// 1 mSec delay constant

#define StartPrg		PORTBbits.RB1
#define TogglesAlim	PORTDbits.RD0
#define EnableL6234	PORTDbits.RD1
#define RunningLED	PORTBbits.RB0
#define InterruptLED	PORTBbits.RB4
#define BugLED			PORTBbits.RB5

void setup_ports(void);
void DelayNmSec(unsigned int N);

struct {
			unsigned RunMotor : 	1;
			unsigned unused 	:		15;
		}	Flags;
unsigned int CMPR, iTime, TimerPrd;

//-----------------------------------------------------------------------------
//	Setup ports
//-----------------------------------------------------------------------------
void setup_ports(void)
{
	// Clear All Ports Prior to defining I/O
	ADPCFG = 0xFFF3;				// all PORTB = Digital(1) ;RB2 et RB3 = analog(0)  ie 0011
	PORTB=0;	//Initialize LED pin data to off state
	PORTC=0;
	PORTD=0;	//disable L6234 RD1=Off
	PORTE=0;
	// Now set pin direction registers
	TRISB = 0xFFCE;	// RB0 LED1 out, RB1 BP2 in, RB2 adc in, RB3 adc in, RB4 LED2 out, RB5 LED3 out
	TRISC = 0xDFFF;			// C13  TX out, C14 RX in, the rest is input / Unused
	TRISD =	0xFFFD; //Set pin as : RD0 BP3 input=1, RD1 output=0 enable L6234, NO debug allowed on EMUC2/EMUD2
	TRISE = 0x0000;		// RE5-0 are the PWMs -> outputs, no FLTA use
}

//-----------------------------------------------------------------------------
//Main routine
int main(void)
{
unsigned int j;
	setup_ports();
	RunningLED=1;						// LED run = On
	RunningLED=0;						// LED run = Off
	while(1)
		{	
		}	// end of while (1)
}	// end of main

//=============================================================================
//Error traps
//-----------------------------------------------------------------------------
//Oscillator Fail Error trap routine
void _ISR _OscillatorFail(void)
{
//	LATDbits.LATD1 = 1; //Turn LED pb on
	BugLED=1;
	while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Address Error trap routine
void _ISR _AddressError(void)
{
	BugLED=1;
	while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Stack Error trap routine
void _ISR _StackError(void)
{
	BugLED=1;
	while(1); //Wait forever
}
//-----------------------------------------------------------------------------
//Math (Arithmetic) Error trap routine
void _ISR _MathError(void)
{
	BugLED=1;
	while(1); //Wait forever
}
//---------------------------------------------------------------------
// This is a generic 1ms delay routine to give a 1mS to 65.5 Seconds delay
// For N = 1 the delay is 1 mS, for N = 65535 the delay is 65,535 mS. 
// Note that FCY is used in the computation.  Please make the necessary
// Changes(PLLx4 or PLLx8 etc) to compute the right FCY as in the define
// statement above.
//---------------------------------------------------------------------
void DelayNmSec(unsigned int N)
{
unsigned int j;
while(N--)
 	for(j=0;j < MILLISEC;j++);
}
//---------------------------------------------------------------------
